import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public abstract class CalculatorButton 
  extends JButton 
  implements ActionListener 
{

  private Calculator calculator;
  private JTextField display;

  CalculatorButton (String label, 
                    Calculator calculator, 
                    JTextField display) 
  {
    super (label);
    this.calculator = calculator;
    this.display = display;
    addActionListener (this);
  }

  public Calculator getCalculator () 
  {
    return calculator;
  }

  public void actionPerformed (ActionEvent e) 
  {
    pressed ();
    display.setText (calculator.toString ());
  }

  // Subclasses must define how to handle a button press.
  public abstract void pressed ();
}
